//game.cpp
#include "includes.h"
#define KWAIT 5
#define MFORCE 1000.0
static int quit = 0;

void run(){
    game agame;
    while(!close_button_pressed && !key[KEY_ESC] && !quit){
        while(!go_on)rest(1); //wait if too fast
        go_on = 0;
        poll_mouse(); //poll the mouse, just in case
        
        agame.update();
        
        draw(bDraw, &agame);
        gfx_update();
        }
    }

meteor::meteor(int kx, int ky){
    int destX = kx;
    int destY = ky;
    speedX = 2.0;
    speedY = 6.0;
    frameskip = 5; //after how many game frames change the frame
    life = (int)(destY/speedY); //time needed to reach
    x = destX + life*speedX; //decide an according X position
    y = 0.0; //alwasy start from the top
    status = S_ALIVE;
    }  
int meteor::getX(int w, int w1){
    if(status == S_ALIVE)return (int)x-w/2;
    return (int)x-w1/2;
    }
int meteor::getY(int h, int h1){
    if(status == S_ALIVE)return (int)y-h;
    return (int)y-h1/2;
    }
int meteor::frame(){
    if(status == S_ALIVE){
        int r = (life/frameskip)%3; //3 is the number of falling animations
        return r;
        }
    else{
        int r = 3 + (life/frameskip)%4; //4 is the number of exploding animations
        return r;
        }
    return 0;
    }
    
int meteor::update(){
    if(status == S_ALIVE){
        if(life){
            life--;
            x -= speedX;
            y += speedY;
            }
        else {
            status = S_ARRIVED; //reached the ground
            life = 40; //60 is a sec, explosion time
            frameskip = 10;
            play(1);
            }
        }
    else if(status == S_ARRIVED){
        if(life)life--;
        else status = S_DEAD;
        }

    return status;
    }
    
granny::granny(){
        x = 0.0;
        y = 55.0 + rand()%(GRID_Y*TILE_S);
        vx = 0.60 + (rand()%4)/10.0;
        vy = 0.0;
        status = S_ALIVE;
        }
        
int granny::update(int terrain, float dx, float dy){
    int t = terrain-1;
    if(status == S_ALIVE){
        x += dx; y+=dy;
        if(t==0){ //slows advancement
            x += vx/2.5;
            y +=vy;}
        else if(t==1){ //brings up
            x += vx;
            y += vy - 0.65;}
        else if(t==2){ //brings down
            x += vx;
            y += vy + 0.65;}
        else {
            x += vx;
            y += vy;
            }
        if(x > GRID_X*TILE_S-3)status = S_ARRIVED;
        if( (y < 55.0) || (y > (50+GRID_Y*TILE_S)) )status = S_DEAD;
        }
        
    return status;
    }
    
game::game(){
    score = 0;
    hard = 0;
    reset(hard); 
    load_highscores();
    //do something
    }
    
game::~game(){
    save_highscores();
    grannyArmy.clear();
    flamestrikes.clear();
    }

void game::reset(int ratio){ //ratio sono i secondi extra per cui giocare
    for(int x=0; x<GRID_X; x++)
        for(int y=0; y<GRID_Y; y++)
            specialGrid[x][y] = 0;
    
    for(int k=0; k<5; k++)
        special[k] = 2;
    special[3] = special[4] = 1;
    mode = S_SETUP;  
    ratio++;
    grannyArmy.clear();
    flamestrikes.clear();
    selection = 0;
    mouseDown = FALSE;
    saved = FALSE;
    dialogFace = 1;
    dialog = count = 0; //vars for the dialog
    sprintf(dialogText[0], " ");
    sprintf(dialogText[1], " ");
    sprintf(dialogText[2], " ");
    time = 60*60*1 + ratio * 600; //each ratio is 10 seconds
    ttime = time; //ttime is the total time
    kw = 0;
    repX = repY = attX = attY = -1; //magnets coordinates
    shieldSTR = 666;
    }
    
void magnet_adjust(int mx, int my, int rx, int ry, int dx, int dy, float *vx, float *vy){
    //first let's calcuate repulsive
    if((rx!=-1) && (ry!=-1)){ //if both those values are -1 it means there is no repulsive force
        float y = ry-dy;
        float x = rx-dx;
        float d  = sqrt( pow(x,2) + pow(y,2));//repulsive diagonal
        if(d > 3.0){ //if there is enough distance
            //float ang = asin(y/d);
            float force = MFORCE / (pow(d,1.87)*1.15);
            *vx = -x/d*force;
            *vy = -y/d*force;
            }
        }
        
    //then let's calcuate the attractive forces
    if((mx!=-1) && (my!=-1)){ //if both those values are -1 it means there is no attractive force
        float y = my-dy;
        float x = mx-dx;
        float d  = sqrt( pow(x,2) + pow(y,2));//repulsive diagonal
        if(d > 7.0){ //if there is enough distance
            float force = MFORCE / (pow(d,1.2)*20); //not the power of the distance, else it's too strong
            *vx += x/d*force;
            *vy += y/d*force;
            }
        }    
    }
    
int game::update(){
    if(kw)kw--; //keyboard timer
    if(shieldSTR<666) //give randomly some strenght back
        if(!(rand()%66))shieldSTR++; 
    if(mode == S_SETUP){
        if(mouse_b & 1){
            if(mouseDown == FALSE){ //se prima non era gi
                mouseDown = TRUE;
                play(3);
                
                if( (mouse_x >screen->w-128) && (mouse_x < screen->w-64) ) {   //selection part
                    if( (mouse_y > TILE_S) && (mouse_y < 5*TILE_S+TILE_S) ){ // IN the grid
                        int my = (mouse_y-TILE_S)/TILE_S;
                        selection = my;
                        }
                    }//END OF SELECTION PART
                if( (mouse_x > 522) && (mouse_x < 522+101) && 
                         (mouse_y > 424) && (mouse_y < 424+48) ) { //CLICKED ON THE START BUTTON
                            mode = S_TALK;
                            count = dialog = 0;
                            }
                else if( (mouse_x > 0) && (mouse_x < GRID_X*TILE_S) ) {   //map part
                    if( (mouse_y > 48) && (mouse_y < GRID_Y*TILE_S+48) ){ // IN the grid
                        int mx = mouse_x/TILE_S, my = (mouse_y-48)/TILE_S;
                        if(specialGrid[mx][my]-1 == selection){
                            specialGrid[mx][my] =0;
                            special[selection]++;
                            }
                        else if(special[selection]){
                            if(specialGrid[mx][my])
                                special[specialGrid[mx][my]-1]++;
                            specialGrid[mx][my] = selection+1;
                            special[selection]--;
                            }
                        }
                    }//END OF map PART
                }
            }//END OF MOUSE CLICK HANDLING
        else mouseDown = FALSE;
        }
    // ############### ACTUAL GAME CODE ################
    else if(mode == S_PLAY){
        if(time)time--;
        //HANDLE CLICKING:
        if(mouse_b & 1){
            if(mouseDown == FALSE){ //se prima non era gi
                mouseDown = TRUE;
                if((mouse_x<(GRID_X*TILE_S+10)) && (mouse_x>0) && 
                    (mouse_y>48) && (mouse_y < (48+GRID_Y*TILE_S)) ){ //if in the play area
                    flamestrikes.push_back(meteor(mouse_x, mouse_y)); //THEN add a meteor
                    play(0);
                    score--;
                    }
                }
            }
        else mouseDown = FALSE;
        
        vector<granny>::iterator gr;
        vector<meteor>::iterator fs;
        if(time){//if the time is not up, add other grannies
            int a;
            if(time < ttime/4) //if we're in the last 4th of the time, spawn more grannies!
                a = rand()%13-hard;
            else
                a = rand()%23-hard;
            if(!a)grannyArmy.push_back(granny());
            }
        
        for(gr = grannyArmy.begin(); gr!=grannyArmy.end(); gr++){
            int kx = (int)gr->x/TILE_S, ky = (int)(gr->y-55)/TILE_S;
            if((kx<0) || (kx>6) || (ky<0) || (ky>5)){
                printf("\nERROR %d %d",kx,ky);
                gr->update(0, 0.0, 0.0); //FOR security reasons
                }
            else {
                float fx = 0.0, fy = 0.0;
                magnet_adjust(attX, attY, repX, repY, (int)gr->x, (int)gr->y,&fx, &fy);
                int res = gr->update(specialGrid[kx][ky], fx, fy);
                if(res == S_ARRIVED)if(!(rand()%30))shieldSTR--;
                }
            }
        //update meteors
        for(fs = flamestrikes.begin(); fs!=flamestrikes.end(); fs++)
            fs->update();
        //check if any meteor has hit a granny
        for(fs = flamestrikes.begin(); fs!=flamestrikes.end(); fs++){
            if(fs->status == S_ARRIVED){
                for(gr = grannyArmy.begin(); gr!=grannyArmy.end(); gr++)
                    if( (abs((int)(gr->x-fs->x))<25) && (abs((int)(gr->y-(fs->y+5)))<25) )
                        gr->status = S_DEAD;
                }
            }
        //erase all dead grannies    
        for(gr = grannyArmy.begin(); gr!=grannyArmy.end(); ){
            if(gr->status == S_DEAD){
                gr = grannyArmy.erase(gr);
                score++;
                }
            else gr++;
            }
        //erase all exploded meteors    
        for(fs = flamestrikes.begin(); fs!=flamestrikes.end(); ){
            if(fs->status == S_DEAD)
                fs = flamestrikes.erase(fs);
            else fs++;
            }
        //victory conditions
        if(!time && grannyArmy.empty()){ //if the time is up and there aren't any other grannies
            mode = S_TALK;
            dialog = 1;
            count = 0;
            play(2);
            }
        //defeat conditions
        if(shieldSTR <= 0){
            mode = S_TALK;
            dialog = 2;
            count = 0;
            }
        }
    // ############### DIALOG CODE - very hackish... ################
    if(mode == S_TALK){
        if(dialog == 0){ //Are you sure...
            if(count==0){
                dialogFace = 1; //YOU, THE EVILO
                sprintf(dialogText[0], "Are you READY?");
                sprintf(dialogText[1], "-YES, bring the grannies on! (PRESS Y)");
                sprintf(dialogText[2], "-No, not yet... (PRESS N)");
                if(!kw && keypressed()){
                    if(key[KEY_N])mode = S_SETUP;
                    if(key[KEY_Y])count++;
                    kw = KWAIT;
                    }
                }
            else if(count==1){
                dialogFace = 5; //CHUCK!
                sprintf(dialogText[0], "Save me granny!  :-(");
                sprintf(dialogText[1], " ");
                sprintf(dialogText[2], "(Press any key to continue...)");
                if(!kw && keypressed()){
                    count++;   
                    kw = KWAIT;
                    }                 
                }
            else if(count==2){
                dialogFace = 2; //granny
                sprintf(dialogText[0], "Have no fear, for I is here!");
                sprintf(dialogText[1], " ");
                sprintf(dialogText[2], "And YOU (points finger) should start running, you evilo!");
                if(!kw && keypressed()){
                    count++;   
                    kw = KWAIT;
                    }                    
                }
            else if(count==3){
                dialogFace = 1; //me
                sprintf(dialogText[0], "Be my guest... HAHAHHAHA!");
                sprintf(dialogText[1], " ");
                sprintf(dialogText[2], " ( press any key and start the battle ) ");
                if(!kw && keypressed()){ 
                    kw = KWAIT;
                    count=0;
                    mode = S_PLAY;
                    
                    //find the magnets:
                    for(int x=0; x<GRID_X; x++){
                        for(int y=0; y<GRID_Y; y++){        
                            if(specialGrid[x][y]==4){ //REPULSE should be 3, ma ho fatto casini...
                                repX = TILE_S/2 + x*TILE_S;
                                repY = TILE_S/2 + y*TILE_S + 52;
                                }
                            else if(specialGrid[x][y]==5){ //ATTRACT should be 4, ma ho fatto casini...
                                attX = TILE_S/2 + x*TILE_S -2;
                                attY = TILE_S/2 + y*TILE_S + 54;
                                }
                            }
                        } //END OF SEARCH CYCLE
                        //printf("\nAtt(%d,%d) Rep(%d,%d)",attX,attY,repX,repY);
                        /*circlefill(screen, attX, attY, 4, makecol(50,200,50));
                        circlefill(screen, repX, repY, 4, makecol(0,250,5));
                        while(!key[KEY_Q])continue;*/
                    } //end of keypressed             
                }//end of COUNT == 3
            }//END OF THE FIRST DIALOG  
        else if(dialog == 1){
            if(count==0){
                dialogFace = 5; //CHUCK!
                sprintf(dialogText[0], "NOOOOOOOOOOO..... :-(");
                sprintf(dialogText[1], " ");
                sprintf(dialogText[2], "(Press any key to continue...)");
                if(!kw && keypressed()){
                    count++;   
                    kw = KWAIT;
                    }                 
                }
            else if(count==1){
                dialogFace = 1; //me!
                sprintf(dialogText[0], "Muahaha... i'm SOO evil...");
                sprintf(dialogText[1], "I killed all the old ladies!");
                sprintf(dialogText[2], " ");
                if(!kw && keypressed()){
                    count++;   
                    kw = KWAIT;
                    }                 
                }
            else if(count==2){
                sprintf(dialogText[0], "You're score: %d",score);
                sprintf(dialogText[1], "Do you want to play again?");
                sprintf(dialogText[2], " (you're score will increase, as the difficulty) ");
                if(!kw && keypressed()){
                    count++;   
                    kw = KWAIT;
                    scores.push_back(score);
                    show_highscores();
                    }           
                }
            else if(count==3){
                dialogFace = 1; //me!
                sprintf(dialogText[0], "YES, it was fun! ( press Y )");
                sprintf(dialogText[1], " ");
                sprintf(dialogText[2], "NO, i've had enough ( press N )");
                if(!kw && keypressed()){
                    if(key[KEY_Y]){
                        mode = S_SETUP;
                        hard++;
                        reset(hard);
                        }
                    if(key[KEY_N])count++;
                    kw = KWAIT;
                    } 
                }
            else if(count==4){
                sprintf(dialogText[0], "I'll keep Chuck locked, don't worry.");
                sprintf(dialogText[1], " ");
                sprintf(dialogText[2], "Come back whenever you want!");
                if(!kw && keypressed()){
                    quit = 1;
                    }                 
                }             
            }//end of 2nd dialog 
        else if(dialog == 2){
            if(count==0){
                dialogFace = 2; //granny
                sprintf(dialogText[0], " ");
                sprintf(dialogText[1], "At last you will meet your end!");
                sprintf(dialogText[2], "...");
                if(!kw && keypressed()){
                    count++;   
                    kw = KWAIT;
                    }                    
                } 
            else if(count==1){
                dialogFace = 1; //me
                sprintf(dialogText[0], "( press N ) NOOO, please spare me!");
                sprintf(dialogText[1], " ");
                sprintf(dialogText[2], "( press M ) My time has come at last...");
                if(!kw && keypressed()){
                    if(key[KEY_N]){
                        count++;
                        score -= 50;
                        }
                    if(key[KEY_M]){
                        count=3;
                        score += 50;
                        }
                    kw = KWAIT;
                    }                    
                }
            else if(count==2){
                dialogFace = 1;
                sprintf(dialogText[0], "You should be ASHAMED");
                sprintf(dialogText[1], "Crying for your life... TSE!");
                sprintf(dialogText[2], " ( SCORE -50 )");
                if(!kw && keypressed()){
                    count = 4;   
                    kw = KWAIT;
                    }                    
                } 
            else if(count==3){
                dialogFace = 1;
                sprintf(dialogText[0], "GOOD, thats the spirit!");
                sprintf(dialogText[1], " ");
                sprintf(dialogText[2], " ( SCORE + 50! )");
                if(!kw && keypressed()){
                    count = 4;   
                    kw = KWAIT;
                    }                    
                }  
            else if(count==4){
                sprintf(dialogText[0], "You're score: %d",score);
                sprintf(dialogText[1], "Do you want to play again?");
                sprintf(dialogText[2], " ");
                if(!kw && keypressed()){
                    count++;   
                    kw = KWAIT;
                    scores.push_back(score);
                    show_highscores();
                    }                
                } 
            else if(count==5){
                dialogFace = 1; //me!
                sprintf(dialogText[0], "YES, it was fun! ( press Y )");
                sprintf(dialogText[1], " ");
                sprintf(dialogText[2], "NO, i've had enough ( press N )");
                if(!kw && keypressed()){
                    if(key[KEY_Y]){
                        mode = S_SETUP;
                        hard = 0;
                        score = 0;
                        reset(hard);
                        }
                    if(key[KEY_N]){
                        dialog = 1;
                        count = 4;
                        }
                    kw = KWAIT;
                    } 
                }      
            }//end of 3rd dialog     
        }//END OF MODE == S_TALK
        clear_keybuf();
    return 0;
    }

void game::load_highscores(){
    if(exists(absolute_path("hi.dat"))){
        FILE *fgame;
        long int l = file_size_ex(absolute_path("hi.dat"));
        fgame = fopen(absolute_path("hi.dat"),"rb"); 
        //printf("\n%d",l);      
        char buff[10];
        for(int k=0; k<l/10; k++){
            fread(buff, sizeof(char), 10, fgame);
            scores.push_back(atoi(buff));
            }
        fclose(fgame);
        }
    else {
        scores.clear();
        for(int k=0; k<10; k++)
            scores.push_back(k*10);
        }  
    //printf("\n List size %d",scores.size());
    }

void game::save_highscores(){
    FILE *fgame;
    list<int>::iterator p;
    fgame = fopen(absolute_path("hi.dat"),"wb");
    char buff[11];
    int k=0;
    for(p = scores.begin(); p!= scores.end(); p++){
            sprintf(buff,"%9d",*p);
            fwrite(buff, sizeof(char), 10, fgame);
            k++;
            if(k>9)break;
            }
    fclose(fgame);
    //printf("\n SList size %d",scores.size());
    }
    
void game::show_highscores(){
    rest(100);
    clear_keybuf();
    list<int>::iterator p;
    scores.sort();
    scores.unique();
    scores.reverse();
    while(!close_button_pressed && !key[KEY_ESC] && !quit){ //THIS IS A MESSY HACK...
        while(!go_on)rest(1); //wait if too fast
        go_on = 0;
        poll_mouse(); //poll the mouse, just in case
        
        draw_score(bDraw, &scores, score);
        if(key[KEY_ENTER])return;
        gfx_update();
        }
    }
