#include "includes.h"
volatile int go_on = 0;
volatile int close_button_pressed = FALSE;

void setup();
void run();
void cleanup();
void load_highscores();

void allow_frame(){
    go_on = 1;
    }
END_OF_FUNCTION(allow_frame)

void close_button_handler(void){
    close_button_pressed = TRUE;
    }
END_OF_FUNCTION(close_button_handler)

int main(){
    setup();
    run();
    cleanup();
    
    return 0;
    }
END_OF_MAIN()

void setup(){
    allegro_init();
    srand(time(NULL));
    install_keyboard();
    install_mouse();
    install_timer();
    install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL);
    
    LOCK_VARIABLE(go_on);
    LOCK_FUNCTION(allow_frame);
    install_int_ex(allow_frame, BPS_TO_TIMER(60));
    
    LOCK_FUNCTION(close_button_handler);
    set_close_button_callback(close_button_handler);
    
    gfx_setup(DOUBLE_BUF + S_WINDOWED, 640, 480, 16);
    gfx_start();
    set_window_title("Granny to the rescue!");
    
    enable_hardware_cursor();
    show_mouse(screen);
    alfont_init();
    
    load_data();
    load_highscores();
    }
    
void cleanup(){
    unload_data();
    alfont_exit();
    gfx_end();
    }

void load_highscores(){
    }
